package io.gitlab.jfronny.muscript.data.dynamic;

import io.gitlab.jfronny.muscript.data.dynamic.additional.DFinal;

import java.util.function.Function;

public non-sealed interface DCallable extends Dynamic<Function<DList, Dynamic<?>>> {
    default Dynamic<?> call(DList args) {
        return getValue().apply(args);
    }

    default Dynamic<?> call(Dynamic<?>... args) {
        return call(DFinal.of(args));
    }
}
